package geniusweb.opponentmodel.bayesian;

import geniusweb.profile.utilityspace.ValueSetUtilities;

/**
 * EXPERIMENTAL. DO NOT USE THIS.
 *
 */
class EvaluatorHypothesis extends Hypothesis {
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((utils == null) ? 0 : utils.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		EvaluatorHypothesis other = (EvaluatorHypothesis) obj;
		if (utils == null) {
			if (other.utils != null)
				return false;
		} else if (!utils.equals(other.utils))
			return false;
		return true;
	}

	private final ValueSetUtilities utils;

	/**
	 * 
	 * @param pEval the ValueSetUtilities utility function
	 */
	public EvaluatorHypothesis(ValueSetUtilities pEval, double p) {
		super(p);
		utils = pEval;
	}

	public ValueSetUtilities getEvaluator() {
		return utils;
	}

	@Override
	public EvaluatorHypothesis with(double p) {
		return new EvaluatorHypothesis(utils, p);
	}

	@Override
	public String toString() {
		return "P(" + utils + ")=" + getProbability();
	}

}
